Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeSimplifier.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeSimplifier.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeSimplifier.cs	(revision 18132)
@@ -36,5 +36,5 @@
     private static readonly Multiplication mulSymbol = new Multiplication();
     private static readonly Division divSymbol = new Division();
-    private static readonly Constant constSymbol = new Constant();
+    private static readonly Number numberSymbol = new Number();
     private static readonly Absolute absSymbol = new Absolute();
     private static readonly Logarithm logSymbol = new Logarithm();
@@ -81,5 +81,5 @@
     private static ISymbolicExpressionTreeNode MacroExpand(ISymbolicExpressionTreeNode root, ISymbolicExpressionTreeNode node,
       IList<ISymbolicExpressionTreeNode> argumentTrees) {
-      List<ISymbolicExpressionTreeNode> subtrees = new List<ISymbolicExpressionTreeNode>(node.Subtrees);
+      var subtrees = new List<ISymbolicExpressionTreeNode>(node.Subtrees);
       while (node.SubtreeCount > 0) node.RemoveSubtree(0);
       if (node.Symbol is InvokeFunction) {
@@ -240,9 +240,14 @@
     }
 
+    private static bool IsNumber(ISymbolicExpressionTreeNode node) {
+      return node.Symbol is Number;
+    }
     private static bool IsConstant(ISymbolicExpressionTreeNode node) {
       return node.Symbol is Constant;
     }
-
-    // dynamic
+    private static bool IsConstantOrNumber(ISymbolicExpressionTreeNode node) {
+      return node is INumericTreeNode;
+    }
+
     private static bool IsTimeLag(ISymbolicExpressionTreeNode node) {
       return node.Symbol is TimeLag;
@@ -261,5 +266,5 @@
     /// <returns></returns>
     public static ISymbolicExpressionTreeNode GetSimplifiedTree(ISymbolicExpressionTreeNode original) {
-      if (IsConstant(original) || IsVariableBase(original)) {
+      if (IsConstantOrNumber(original) || IsVariableBase(original)) {
         return (ISymbolicExpressionTreeNode)original.Clone();
       } else if (IsAbsolute(original)) {
@@ -324,8 +329,8 @@
     private static ISymbolicExpressionTreeNode SimplifyAny(ISymbolicExpressionTreeNode original) {
       // can't simplify this function but simplify all subtrees 
-      List<ISymbolicExpressionTreeNode> subtrees = new List<ISymbolicExpressionTreeNode>(original.Subtrees);
+      var subtrees = new List<ISymbolicExpressionTreeNode>(original.Subtrees);
       while (original.Subtrees.Count() > 0) original.RemoveSubtree(0);
       var clone = (SymbolicExpressionTreeNode)original.Clone();
-      List<ISymbolicExpressionTreeNode> simplifiedSubtrees = new List<ISymbolicExpressionTreeNode>();
+      var simplifiedSubtrees = new List<ISymbolicExpressionTreeNode>();
       foreach (var subtree in subtrees) {
         simplifiedSubtrees.Add(GetSimplifiedTree(subtree));
@@ -335,12 +340,12 @@
         clone.AddSubtree(simplifiedSubtree);
       }
-      if (simplifiedSubtrees.TrueForAll(t => IsConstant(t))) {
-        SimplifyConstantExpression(clone);
+      if (simplifiedSubtrees.TrueForAll(IsNumber)) {
+        FoldNumbers(clone);
       }
       return clone;
     }
 
-    private static ISymbolicExpressionTreeNode SimplifyConstantExpression(ISymbolicExpressionTreeNode original) {
-      // not yet implemented
+    private static ISymbolicExpressionTreeNode FoldNumbers(ISymbolicExpressionTreeNode original) {
+      // TODO not implemented
       return original;
     }
@@ -354,6 +359,6 @@
         var sum = original.Subtrees
           .Select(GetSimplifiedTree)
-          .Aggregate(MakeSum);
-        return MakeFraction(sum, MakeConstant(original.Subtrees.Count()));
+          .Aggregate(Sum);
+        return Fraction(sum, Number(original.Subtrees.Count()));
       }
     }
@@ -369,6 +374,6 @@
         var remaining = original.Subtrees.Skip(2);
         return
-          MakeProduct(GetSimplifiedTree(first),
-            Invert(remaining.Aggregate(GetSimplifiedTree(second), (a, b) => MakeProduct(a, GetSimplifiedTree(b)))));
+          Product(GetSimplifiedTree(first),
+            Invert(remaining.Aggregate(GetSimplifiedTree(second), (a, b) => Product(a, GetSimplifiedTree(b)))));
       }
     }
@@ -380,5 +385,5 @@
         return original.Subtrees
           .Select(GetSimplifiedTree)
-          .Aggregate(MakeProduct);
+          .Aggregate(Product);
       }
     }
@@ -392,5 +397,5 @@
         var first = original.Subtrees.First();
         var remaining = original.Subtrees.Skip(1);
-        return remaining.Aggregate(GetSimplifiedTree(first), (a, b) => MakeSum(a, Negate(GetSimplifiedTree(b))));
+        return remaining.Aggregate(GetSimplifiedTree(first), (a, b) => Sum(a, Negate(GetSimplifiedTree(b))));
       }
     }
@@ -404,14 +409,14 @@
         return original.Subtrees
           .Select(GetSimplifiedTree)
-          .Aggregate(MakeSum);
+          .Aggregate(Sum);
       }
     }
 
     private static ISymbolicExpressionTreeNode SimplifyAbsolute(ISymbolicExpressionTreeNode original) {
-      return MakeAbs(GetSimplifiedTree(original.GetSubtree(0)));
+      return Abs(GetSimplifiedTree(original.GetSubtree(0)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifyNot(ISymbolicExpressionTreeNode original) {
-      return MakeNot(GetSimplifiedTree(original.GetSubtree(0)));
+      return Not(GetSimplifiedTree(original.GetSubtree(0)));
     }
 
@@ -419,5 +424,5 @@
       return original.Subtrees
         .Select(GetSimplifiedTree)
-        .Aggregate(MakeOr);
+        .Aggregate(Or);
     }
 
@@ -425,65 +430,65 @@
       return original.Subtrees
         .Select(GetSimplifiedTree)
-        .Aggregate(MakeAnd);
+        .Aggregate(And);
     }
 
     private static ISymbolicExpressionTreeNode SimplifyLessThan(ISymbolicExpressionTreeNode original) {
-      return MakeLessThan(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)));
+      return LessThan(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifyGreaterThan(ISymbolicExpressionTreeNode original) {
-      return MakeGreaterThan(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)));
+      return GreaterThan(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifyIfThenElse(ISymbolicExpressionTreeNode original) {
-      return MakeIfThenElse(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)),
+      return IfThenElse(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)),
         GetSimplifiedTree(original.GetSubtree(2)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifyTangent(ISymbolicExpressionTreeNode original) {
-      return MakeTangent(GetSimplifiedTree(original.GetSubtree(0)));
+      return Tangent(GetSimplifiedTree(original.GetSubtree(0)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifyCosine(ISymbolicExpressionTreeNode original) {
-      return MakeCosine(GetSimplifiedTree(original.GetSubtree(0)));
+      return Cosine(GetSimplifiedTree(original.GetSubtree(0)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifySine(ISymbolicExpressionTreeNode original) {
-      return MakeSine(GetSimplifiedTree(original.GetSubtree(0)));
+      return Sine(GetSimplifiedTree(original.GetSubtree(0)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifyExp(ISymbolicExpressionTreeNode original) {
-      return MakeExp(GetSimplifiedTree(original.GetSubtree(0)));
+      return Exp(GetSimplifiedTree(original.GetSubtree(0)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifySquare(ISymbolicExpressionTreeNode original) {
-      return MakeSquare(GetSimplifiedTree(original.GetSubtree(0)));
+      return Square(GetSimplifiedTree(original.GetSubtree(0)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifySquareRoot(ISymbolicExpressionTreeNode original) {
-      return MakeSquareRoot(GetSimplifiedTree(original.GetSubtree(0)));
+      return SquareRoot(GetSimplifiedTree(original.GetSubtree(0)));
     }
     private static ISymbolicExpressionTreeNode SimplifyCube(ISymbolicExpressionTreeNode original) {
-      return MakeCube(GetSimplifiedTree(original.GetSubtree(0)));
+      return Cube(GetSimplifiedTree(original.GetSubtree(0)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifyCubeRoot(ISymbolicExpressionTreeNode original) {
-      return MakeCubeRoot(GetSimplifiedTree(original.GetSubtree(0)));
+      return CubeRoot(GetSimplifiedTree(original.GetSubtree(0)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifyLog(ISymbolicExpressionTreeNode original) {
-      return MakeLog(GetSimplifiedTree(original.GetSubtree(0)));
+      return Log(GetSimplifiedTree(original.GetSubtree(0)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifyRoot(ISymbolicExpressionTreeNode original) {
-      return MakeRoot(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)));
+      return Root(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifyPower(ISymbolicExpressionTreeNode original) {
-      return MakePower(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)));
+      return Power(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)));
     }
 
     private static ISymbolicExpressionTreeNode SimplifyAnalyticalQuotient(ISymbolicExpressionTreeNode original) {
-      return MakeAnalyticalQuotient(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)));
+      return AQ(GetSimplifiedTree(original.GetSubtree(0)), GetSimplifiedTree(original.GetSubtree(1)));
     }
 
@@ -494,5 +499,5 @@
         return AddLagToDynamicNodes(simplifiedSubtree, laggedTreeNode.Lag);
       } else {
-        return MakeTimeLag(simplifiedSubtree, laggedTreeNode.Lag);
+        return Lag(simplifiedSubtree, laggedTreeNode.Lag);
       }
     }
@@ -501,8 +506,8 @@
       var laggedTreeNode = original as ILaggedTreeNode;
       var simplifiedSubtree = GetSimplifiedTree(original.GetSubtree(0));
-      if (IsConstant(simplifiedSubtree)) {
-        return GetSimplifiedTree(MakeProduct(simplifiedSubtree, MakeConstant(-laggedTreeNode.Lag)));
-      } else {
-        return MakeIntegral(simplifiedSubtree, laggedTreeNode.Lag);
+      if (IsConstantOrNumber(simplifiedSubtree)) {
+        return GetSimplifiedTree(Product(simplifiedSubtree, Number(-laggedTreeNode.Lag)));
+      } else {
+        return Integral(simplifiedSubtree, laggedTreeNode.Lag);
       }
     }
@@ -512,7 +517,7 @@
     #region low level tree restructuring
 
-    private static ISymbolicExpressionTreeNode MakeTimeLag(ISymbolicExpressionTreeNode subtree, int lag) {
+    private static ISymbolicExpressionTreeNode Lag(ISymbolicExpressionTreeNode subtree, int lag) {
       if (lag == 0) return subtree;
-      if (IsConstant(subtree)) return subtree;
+      if (IsConstantOrNumber(subtree)) return subtree;
       var lagNode = (LaggedTreeNode)timeLagSymbol.CreateTreeNode();
       lagNode.Lag = lag;
@@ -521,8 +526,8 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeIntegral(ISymbolicExpressionTreeNode subtree, int lag) {
+    private static ISymbolicExpressionTreeNode Integral(ISymbolicExpressionTreeNode subtree, int lag) {
       if (lag == 0) return subtree;
       else if (lag == -1 || lag == 1) {
-        return MakeSum(subtree, AddLagToDynamicNodes((ISymbolicExpressionTreeNode)subtree.Clone(), lag));
+        return Sum(subtree, AddLagToDynamicNodes((ISymbolicExpressionTreeNode)subtree.Clone(), lag));
       } else {
         var node = (LaggedTreeNode)integralSymbol.CreateTreeNode();
@@ -533,9 +538,9 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeNot(ISymbolicExpressionTreeNode t) {
-      if (IsConstant(t)) {
-        var constNode = t as ConstantTreeNode;
-        if (constNode.Value > 0) return MakeConstant(-1.0);
-        else return MakeConstant(1.0);
+    private static ISymbolicExpressionTreeNode Not(ISymbolicExpressionTreeNode t) {
+      if (IsNumber(t)) {
+        var numNode = t as NumberTreeNode;
+        if (numNode.Value > 0) return Number(-1.0);
+        else return Number(1.0);
       } else if (IsNot(t)) {
         return t.GetSubtree(0);
@@ -543,5 +548,5 @@
         var gtNode = gtSymbol.CreateTreeNode();
         gtNode.AddSubtree(t);
-        gtNode.AddSubtree(MakeConstant(0.0));
+        gtNode.AddSubtree(Number(0.0));
         var notNode = notSymbol.CreateTreeNode();
         notNode.AddSubtree(gtNode);
@@ -554,22 +559,22 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeOr(ISymbolicExpressionTreeNode a, ISymbolicExpressionTreeNode b) {
-      if (IsConstant(a) && IsConstant(b)) {
-        var constA = a as ConstantTreeNode;
-        var constB = b as ConstantTreeNode;
-        if (constA.Value > 0.0 || constB.Value > 0.0) {
-          return MakeConstant(1.0);
+    private static ISymbolicExpressionTreeNode Or(ISymbolicExpressionTreeNode a, ISymbolicExpressionTreeNode b) {
+      if (IsNumber(a) && IsNumber(b)) {
+        var aNode = a as NumberTreeNode;
+        var bNode = b as NumberTreeNode;
+        if (aNode.Value > 0.0 || bNode.Value > 0.0) {
+          return Number(1.0);
         } else {
-          return MakeConstant(-1.0);
-        }
-      } else if (IsConstant(a)) {
-        return MakeOr(b, a);
-      } else if (IsConstant(b)) {
-        var constT = b as ConstantTreeNode;
-        if (constT.Value > 0.0) {
+          return Number(-1.0);
+        }
+      } else if (IsNumber(a)) {
+        return Or(b, a);
+      } else if (IsNumber(b)) {
+        var bNode = b as NumberTreeNode;
+        if (bNode.Value > 0.0) {
           // boolean expression is necessarily true
-          return MakeConstant(1.0);
+          return Number(1.0);
         } else {
-          // the constant value has no effect on the result of the boolean condition so we can drop the constant term
+          // the value has no effect on the result of the boolean condition so we can drop the number
           var orNode = orSymbol.CreateTreeNode();
           orNode.AddSubtree(a);
@@ -584,19 +589,19 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeAnd(ISymbolicExpressionTreeNode a, ISymbolicExpressionTreeNode b) {
-      if (IsConstant(a) && IsConstant(b)) {
-        var constA = a as ConstantTreeNode;
-        var constB = b as ConstantTreeNode;
-        if (constA.Value > 0.0 && constB.Value > 0.0) {
-          return MakeConstant(1.0);
+    private static ISymbolicExpressionTreeNode And(ISymbolicExpressionTreeNode a, ISymbolicExpressionTreeNode b) {
+      if (IsNumber(a) && IsNumber(b)) {
+        var aNode = a as NumberTreeNode;
+        var bNode = b as NumberTreeNode;
+        if (aNode.Value > 0.0 && bNode.Value > 0.0) {
+          return Number(1.0);
         } else {
-          return MakeConstant(-1.0);
-        }
-      } else if (IsConstant(a)) {
-        return MakeAnd(b, a);
-      } else if (IsConstant(b)) {
-        var constB = b as ConstantTreeNode;
-        if (constB.Value > 0.0) {
-          // the constant value has no effect on the result of the boolean condition so we can drop the constant term
+          return Number(-1.0);
+        }
+      } else if (IsNumber(a)) {
+        return And(b, a);
+      } else if (IsNumber(b)) {
+        var bNode = b as NumberTreeNode;
+        if (bNode.Value > 0.0) {
+          // the value has no effect on the result of the boolean condition so we can drop the number
           var andNode = andSymbol.CreateTreeNode();
           andNode.AddSubtree(a);
@@ -604,5 +609,5 @@
         } else {
           // boolean expression is necessarily false
-          return MakeConstant(-1.0);
+          return Number(-1.0);
         }
       } else {
@@ -614,11 +619,11 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeLessThan(ISymbolicExpressionTreeNode leftSide,
+    private static ISymbolicExpressionTreeNode LessThan(ISymbolicExpressionTreeNode leftSide,
       ISymbolicExpressionTreeNode rightSide) {
-      if (IsConstant(leftSide) && IsConstant(rightSide)) {
-        var lsConst = leftSide as ConstantTreeNode;
-        var rsConst = rightSide as ConstantTreeNode;
-        if (lsConst.Value < rsConst.Value) return MakeConstant(1.0);
-        else return MakeConstant(-1.0);
+      if (IsNumber(leftSide) && IsNumber(rightSide)) {
+        var lsNode = leftSide as NumberTreeNode;
+        var rsNode = rightSide as NumberTreeNode;
+        if (lsNode.Value < rsNode.Value) return Number(1.0);
+        else return Number(-1.0);
       } else {
         var ltNode = ltSymbol.CreateTreeNode();
@@ -629,11 +634,11 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeGreaterThan(ISymbolicExpressionTreeNode leftSide,
+    private static ISymbolicExpressionTreeNode GreaterThan(ISymbolicExpressionTreeNode leftSide,
       ISymbolicExpressionTreeNode rightSide) {
-      if (IsConstant(leftSide) && IsConstant(rightSide)) {
-        var lsConst = leftSide as ConstantTreeNode;
-        var rsConst = rightSide as ConstantTreeNode;
-        if (lsConst.Value > rsConst.Value) return MakeConstant(1.0);
-        else return MakeConstant(-1.0);
+      if (IsNumber(leftSide) && IsNumber(rightSide)) {
+        var lsNode = leftSide as NumberTreeNode;
+        var rsNode = rightSide as NumberTreeNode;
+        if (lsNode.Value > rsNode.Value) return Number(1.0);
+        else return Number(-1.0);
       } else {
         var gtNode = gtSymbol.CreateTreeNode();
@@ -644,9 +649,9 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeIfThenElse(ISymbolicExpressionTreeNode condition,
+    private static ISymbolicExpressionTreeNode IfThenElse(ISymbolicExpressionTreeNode condition,
       ISymbolicExpressionTreeNode trueBranch, ISymbolicExpressionTreeNode falseBranch) {
-      if (IsConstant(condition)) {
-        var constT = condition as ConstantTreeNode;
-        if (constT.Value > 0.0) return trueBranch;
+      if (IsConstantOrNumber(condition)) {
+        var condNode = condition as INumericTreeNode;
+        if (condNode.Value > 0.0) return trueBranch;
         else return falseBranch;
       } else {
@@ -657,5 +662,5 @@
           var gtNode = gtSymbol.CreateTreeNode();
           gtNode.AddSubtree(condition);
-          gtNode.AddSubtree(MakeConstant(0.0));
+          gtNode.AddSubtree(Number(0.0));
           ifNode.AddSubtree(gtNode);
         }
@@ -666,14 +671,14 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeSine(ISymbolicExpressionTreeNode node) {
-      if (IsConstant(node)) {
-        var constT = node as ConstantTreeNode;
-        return MakeConstant(Math.Sin(constT.Value));
+    private static ISymbolicExpressionTreeNode Sine(ISymbolicExpressionTreeNode node) {
+      if (IsNumber(node)) {
+        var numNode = node as NumberTreeNode;
+        return Number(Math.Sin(numNode.Value));
       } else if (IsFactor(node)) {
         var factor = node as FactorVariableTreeNode;
-        return MakeFactor(factor.Symbol, factor.VariableName, factor.Weights.Select(Math.Sin));
+        return Factor(factor.Symbol, factor.VariableName, factor.Weights.Select(Math.Sin));
       } else if (IsBinFactor(node)) {
         var binFactor = node as BinaryFactorVariableTreeNode;
-        return MakeBinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, Math.Sin(binFactor.Weight));
+        return BinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, Math.Sin(binFactor.Weight));
       } else {
         var sineNode = sineSymbol.CreateTreeNode();
@@ -683,14 +688,14 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeTangent(ISymbolicExpressionTreeNode node) {
-      if (IsConstant(node)) {
-        var constT = node as ConstantTreeNode;
-        return MakeConstant(Math.Tan(constT.Value));
+    private static ISymbolicExpressionTreeNode Tangent(ISymbolicExpressionTreeNode node) {
+      if (IsNumber(node)) {
+        var numNode = node as NumberTreeNode;
+        return Number(Math.Tan(numNode.Value));
       } else if (IsFactor(node)) {
         var factor = node as FactorVariableTreeNode;
-        return MakeFactor(factor.Symbol, factor.VariableName, factor.Weights.Select(Math.Tan));
+        return Factor(factor.Symbol, factor.VariableName, factor.Weights.Select(Math.Tan));
       } else if (IsBinFactor(node)) {
         var binFactor = node as BinaryFactorVariableTreeNode;
-        return MakeBinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, Math.Tan(binFactor.Weight));
+        return BinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, Math.Tan(binFactor.Weight));
       } else {
         var tanNode = tanSymbol.CreateTreeNode();
@@ -700,16 +705,16 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeCosine(ISymbolicExpressionTreeNode node) {
-      if (IsConstant(node)) {
-        var constT = node as ConstantTreeNode;
-        return MakeConstant(Math.Cos(constT.Value));
+    private static ISymbolicExpressionTreeNode Cosine(ISymbolicExpressionTreeNode node) {
+      if (IsNumber(node)) {
+        var numNode = node as NumberTreeNode;
+        return Number(Math.Cos(numNode.Value));
       } else if (IsFactor(node)) {
         var factor = node as FactorVariableTreeNode;
-        return MakeFactor(factor.Symbol, factor.VariableName, factor.Weights.Select(Math.Cos));
+        return Factor(factor.Symbol, factor.VariableName, factor.Weights.Select(Math.Cos));
       } else if (IsBinFactor(node)) {
         var binFactor = node as BinaryFactorVariableTreeNode;
         // cos(0) = 1 see similar case for Exp(binfactor)
-        return MakeSum(MakeBinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, Math.Cos(binFactor.Weight) - 1),
-          MakeConstant(1.0));
+        return Sum(BinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, Math.Cos(binFactor.Weight) - 1),
+          Number(1.0));
       } else {
         var cosNode = cosineSymbol.CreateTreeNode();
@@ -719,22 +724,22 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeExp(ISymbolicExpressionTreeNode node) {
-      if (IsConstant(node)) {
-        var constT = node as ConstantTreeNode;
-        return MakeConstant(Math.Exp(constT.Value));
+    private static ISymbolicExpressionTreeNode Exp(ISymbolicExpressionTreeNode node) {
+      if (IsNumber(node)) {
+        var numNode = node as NumberTreeNode;
+        return Number(Math.Exp(numNode.Value));
       } else if (IsFactor(node)) {
         var factNode = node as FactorVariableTreeNode;
-        return MakeFactor(factNode.Symbol, factNode.VariableName, factNode.Weights.Select(w => Math.Exp(w)));
+        return Factor(factNode.Symbol, factNode.VariableName, factNode.Weights.Select(w => Math.Exp(w)));
       } else if (IsBinFactor(node)) {
         // exp( binfactor w val=a) = if(val=a) exp(w) else exp(0) = binfactor( (exp(w) - 1) val a) + 1
         var binFactor = node as BinaryFactorVariableTreeNode;
         return
-          MakeSum(MakeBinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, Math.Exp(binFactor.Weight) - 1), MakeConstant(1.0));
+          Sum(BinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, Math.Exp(binFactor.Weight) - 1), Number(1.0));
       } else if (IsLog(node)) {
         return node.GetSubtree(0);
       } else if (IsAddition(node)) {
-        return node.Subtrees.Select(s => MakeExp(s)).Aggregate((s, t) => MakeProduct(s, t));
+        return node.Subtrees.Select(s => Exp(s)).Aggregate((s, t) => Product(s, t));
       } else if (IsSubtraction(node)) {
-        return node.Subtrees.Select(s => MakeExp(s)).Aggregate((s, t) => MakeProduct(s, Negate(t)));
+        return node.Subtrees.Select(s => Exp(s)).Aggregate((s, t) => Product(s, Negate(t)));
       } else {
         var expNode = expSymbol.CreateTreeNode();
@@ -743,15 +748,15 @@
       }
     }
-    private static ISymbolicExpressionTreeNode MakeLog(ISymbolicExpressionTreeNode node) {
-      if (IsConstant(node)) {
-        var constT = node as ConstantTreeNode;
-        return MakeConstant(Math.Log(constT.Value));
+    private static ISymbolicExpressionTreeNode Log(ISymbolicExpressionTreeNode node) {
+      if (IsNumber(node)) {
+        var numNode = node as NumberTreeNode;
+        return Number(Math.Log(numNode.Value));
       } else if (IsFactor(node)) {
         var factNode = node as FactorVariableTreeNode;
-        return MakeFactor(factNode.Symbol, factNode.VariableName, factNode.Weights.Select(w => Math.Log(w)));
+        return Factor(factNode.Symbol, factNode.VariableName, factNode.Weights.Select(w => Math.Log(w)));
       } else if (IsExp(node)) {
         return node.GetSubtree(0);
       } else if (IsSquareRoot(node)) {
-        return MakeFraction(MakeLog(node.GetSubtree(0)), MakeConstant(2.0));
+        return Fraction(Log(node.GetSubtree(0)), Number(2.0));
       } else {
         var logNode = logSymbol.CreateTreeNode();
@@ -761,14 +766,14 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeSquare(ISymbolicExpressionTreeNode node) {
-      if (IsConstant(node)) {
-        var constT = node as ConstantTreeNode;
-        return MakeConstant(constT.Value * constT.Value);
+    private static ISymbolicExpressionTreeNode Square(ISymbolicExpressionTreeNode node) {
+      if (IsNumber(node)) {
+        var numNode = node as NumberTreeNode;
+        return Number(numNode.Value * numNode.Value);
       } else if (IsFactor(node)) {
         var factNode = node as FactorVariableTreeNode;
-        return MakeFactor(factNode.Symbol, factNode.VariableName, factNode.Weights.Select(w => w * w));
+        return Factor(factNode.Symbol, factNode.VariableName, factNode.Weights.Select(w => w * w));
       } else if (IsBinFactor(node)) {
         var binFactor = node as BinaryFactorVariableTreeNode;
-        return MakeBinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, binFactor.Weight * binFactor.Weight);
+        return BinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, binFactor.Weight * binFactor.Weight);
       } else if (IsSquareRoot(node)) {
         return node.GetSubtree(0);
@@ -777,15 +782,15 @@
         var mulNode = mulSymbol.CreateTreeNode();
         foreach (var subtree in node.Subtrees) {
-          mulNode.AddSubtree(MakeSquare(subtree));
+          mulNode.AddSubtree(Square(subtree));
         }
         return mulNode;
       } else if (IsAbsolute(node)) {
-        return MakeSquare(node.GetSubtree(0)); // sqr(abs(x)) = sqr(x)
+        return Square(node.GetSubtree(0)); // sqr(abs(x)) = sqr(x)
       } else if (IsExp(node)) {
-        return MakeExp(MakeProduct(node.GetSubtree(0), MakeConstant(2.0))); // sqr(exp(x)) = exp(2x)
+        return Exp(Product(node.GetSubtree(0), Number(2.0))); // sqr(exp(x)) = exp(2x)
       } else if (IsSquare(node)) {
-        return MakePower(node.GetSubtree(0), MakeConstant(4));
+        return Power(node.GetSubtree(0), Number(4));
       } else if (IsCube(node)) {
-        return MakePower(node.GetSubtree(0), MakeConstant(6));
+        return Power(node.GetSubtree(0), Number(6));
       } else {
         var sqrNode = sqrSymbol.CreateTreeNode();
@@ -795,22 +800,22 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeCube(ISymbolicExpressionTreeNode node) {
-      if (IsConstant(node)) {
-        var constT = node as ConstantTreeNode;
-        return MakeConstant(constT.Value * constT.Value * constT.Value);
+    private static ISymbolicExpressionTreeNode Cube(ISymbolicExpressionTreeNode node) {
+      if (IsNumber(node)) {
+        var numNode = node as NumberTreeNode;
+        return Number(numNode.Value * numNode.Value * numNode.Value);
       } else if (IsFactor(node)) {
         var factNode = node as FactorVariableTreeNode;
-        return MakeFactor(factNode.Symbol, factNode.VariableName, factNode.Weights.Select(w => w * w * w));
+        return Factor(factNode.Symbol, factNode.VariableName, factNode.Weights.Select(w => w * w * w));
       } else if (IsBinFactor(node)) {
         var binFactor = node as BinaryFactorVariableTreeNode;
-        return MakeBinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, binFactor.Weight * binFactor.Weight * binFactor.Weight);
+        return BinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, binFactor.Weight * binFactor.Weight * binFactor.Weight);
       } else if (IsCubeRoot(node)) {
         return node.GetSubtree(0); // NOTE: not really accurate because cuberoot(x) with negative x is evaluated to NaN and after this simplification we evaluate as x
       } else if (IsExp(node)) {
-        return MakeExp(MakeProduct(node.GetSubtree(0), MakeConstant(3)));
+        return Exp(Product(node.GetSubtree(0), Number(3)));
       } else if (IsSquare(node)) {
-        return MakePower(node.GetSubtree(0), MakeConstant(6));
+        return Power(node.GetSubtree(0), Number(6));
       } else if (IsCube(node)) {
-        return MakePower(node.GetSubtree(0), MakeConstant(9));
+        return Power(node.GetSubtree(0), Number(9));
       } else {
         var cubeNode = cubeSymbol.CreateTreeNode();
@@ -820,14 +825,14 @@
     }
 
-    private static ISymbolicExpressionTreeNode MakeAbs(ISymbolicExpressionTreeNode node) {
-      if (IsConstant(node)) {
-        var constT = node as ConstantTreeNode;
-        return MakeConstant(Math.Abs(constT.Value));
+    private static ISymbolicExpressionTreeNode Abs(ISymbolicExpressionTreeNode node) {
+      if (IsNumber(node)) {
+        var numNode = node as NumberTreeNode;
+        return Number(Math.Abs(numNode.Value));
       } else if (IsFactor(node)) {
         var factNode = node as FactorVariableTreeNode;
-        return MakeFactor(factNode.Symbol, factNode.VariableName, factNode.Weights.Select(w => Math.Abs(w)));
+        return Factor(factNode.Symbol, factNode.VariableName, factNode.Weights.Select(w => Math.Abs(w)));
       } else if (IsBinFactor(node)) {
         var binFactor = node as BinaryFactorVariableTreeNode;
-        return MakeBinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, Math.Abs(binFactor.Weight));
+        return BinFactor(binFactor.Symbol, binFactor.VariableName, binFactor.VariableValue, Math.Abs(binFactor.Weight));
       } else if (IsSquare(node) || IsExp(node) || IsSquareRoot(node) || IsCubeRoot(node)) {
         return node; // abs(sqr(x)) = sqr(x), abs(exp(x)) = exp(x) ...
@@ -835,5 +840,5 @@
         var mul = mulSymbol.CreateTreeNode();
         foreach (var st in node.Subtrees) {
-          mul.AddSubtree(MakeAbs(st));
+          mul.AddSubtree(Abs(st));
         }
         return mul;
@@ -841,5 +846,5 @@
         var div = divSymbol.CreateTreeNode();
         foreach (var st in node.Subtrees) {
-          div.AddSubtree(MakeAbs(st));
+          div.AddSubtree(Abs(st));
         }
         return div;
